#ifndef __IKD_TOOLS_CLIENTRENDERER_H__
#define __IKD_TOOLS_CLIENTRENDERER_H__

// NCAg̈BMPtbv`
//
//  ̃NXpinnerDraw\bhI[o[Ch
//  Rp`uBMP֕`悵tbv܂i`掞̂Ȃ܂j

#include <windows.h>
#include <functional>

namespace Tools {

	class ClientRenderer {
	public:
		ClientRenderer() : screenWidth_(), screenHeight_(), compBmp_(), compHdc_() {}
		virtual ~ClientRenderer() {
			if ( compBmp_ != 0 )
				DeleteObject( compBmp_ );
			if ( compHdc_ != 0 )
				DeleteDC( compHdc_ );
		}

		// `
		void draw( HWND hWnd, HDC hdc ) {
			RECT r;
			GetClientRect( hWnd, &r );
			int w = r.right - r.left;
			int h = r.bottom - r.top;

			bool isUpdate = false;
			if ( w != screenWidth_ || h != screenHeight_ ) {
				screenWidth_ = w;
				screenHeight_ = h;
				resize( hWnd, hdc, screenWidth_, screenHeight_ );
				isUpdate = true;
			}

			if ( isUpdate == true ) {
				if ( compBmp_ != 0 ) {
					DeleteObject( compBmp_ );
				}
				if ( compHdc_ == 0 ) {
					compHdc_ = CreateCompatibleDC( hdc );
				}
				// Rp`uBMP쐬ƃReLXgA^b`
				compBmp_ = CreateCompatibleBitmap( hdc, screenWidth_, screenHeight_ );
				SelectObject( compHdc_, compBmp_ );
			}

			// `
			HBRUSH brush = (HBRUSH)GetStockObject( WHITE_BRUSH );
			auto preBrush = SelectObject( compHdc_, brush );
			Rectangle( compHdc_, -1, -1, screenWidth_ + 1, screenHeight_ + 1 );
			SelectObject( compHdc_, preBrush );

			innerDraw( hWnd, compHdc_ );

			// tbv
			BitBlt( hdc, 0, 0, screenWidth_, screenHeight_, compHdc_, 0, 0, SRCCOPY );
		}

	protected:
		// TCY
		virtual void resize( HWND hwnd, HDC hdc, int w, int h ) {
		}

		// `
		virtual void innerDraw( HWND hwnd, HDC hdc ) {
		}

		int getScreenWidth() {
			return screenWidth_;
		}
		int getScreenHeight() {
			return screenHeight_;
		}

		int screenWidth_;
		int screenHeight_;
		HBITMAP compBmp_;
		HDC compHdc_;
	};
}

#endif
