#ifndef __IKD_TOOLS_DOUBLE2_H__
#define __IKD_TOOLS_DOUBLE2_H__

// 2_

namespace Tools {
	
	template< class FLT >
	class Float2Base {
	public:
		Float2Base() {}
		Float2Base( const FLT &x, const FLT &y ) : x( x ), y( y ) {}
		Float2Base<FLT> operator +( const Float2Base<FLT> &r ) const {
			return Float2Base<FLT>( x + r.x, y + r.y );
		}
		Float2Base<FLT> operator -( const Float2Base<FLT> &r ) const {
			return Float2Base<FLT>( x - r.x, y - r.y );
		}
		Float2Base<FLT> operator *( const Float2Base<FLT> &r ) const {
			return Float2Base<FLT>( x * r.x, y * r.y );
		}
		Float2Base<FLT> operator /( const Float2Base<FLT> &r ) const {
			return Float2Base<FLT>( x / r.x, y / r.y );
		}
		Float2Base<FLT> operator *( const FLT &r ) const {
			return Float2Base<FLT>( x * r, y * r );
		}
		Float2Base<FLT> operator /( const FLT &r ) const {
			return Float2Base<FLT>( x / r, y / r );
		}
		Float2Base<FLT> &operator +=( const Float2Base<FLT> &r ) {
			x += r.x;
			y += r.y;
			return *this;
		}
		Float2Base<FLT> &operator -=( const Float2Base<FLT> &r ) {
			x -= r.x;
			y -= r.y;
			return *this;
		}
		Float2Base<FLT> &operator *=( const Float2Base<FLT> &r ) {
			x *= r.x;
			y *= r.y;
			return *this;
		}
		Float2Base<FLT> &operator *=( const float &r ) {
			x *= r;
			y *= r;
			return *this;
		}
		Float2Base<FLT> &operator /=( const Float2Base<FLT> &r ) {
			x /= r.x;
			y /= r.y;
			return *this;
		}
		Float2Base<FLT> &operator /=( const int32_t &r ) {
			x /= r;
			y /= r;
			return *this;
		}
		bool operator ==( const Float2Base<FLT> &r ) const {
			return ( x == r.x && y == r.y );
		}
		FLT x;
		FLT y;
	};

	typedef Float2Base<float> Float2;
	typedef Float2Base<double> Double2;
}

#endif
