#ifndef __IKD_SHAPEFILE_SHAPEFILEDB_H__
#define __IKD_SHAPEFILE_SHAPEFILEDB_H__

#include <fstream>
#include <vector>

namespace ShapeFile {

	class ShapeFileDB {
		struct Data {
			std::string pref_;	// s{
			std::string city_;	// s
		};

	public:
		bool create( const char* fileName ) {

			std::ifstream ifs;
			ifs.open( fileName );
			if ( ifs.is_open() == false )
				return false;

			char buf[ 1024 ];
			while ( ifs.eof() == false ) {
				ifs.getline( buf, 1024 );
				std::string s( buf );
				auto ss = split( s, '\t' );
				Data data;
				data.pref_ = ss[ 1 ];
				data.city_ = ss[ 2 ];
				dataList_.push_back( data );
			}

			ifs.close();

			return true;
		}

		// f[^擾
		const Data &getData( int index ) {
			return dataList_[ index ];
		}

		// f[^擾
		size_t getDataSize() const {
			return dataList_.size();
		}

	private:
		std::vector< std::string > split( std::string str, const char delim ) {
			std::vector< std::string > list;
			size_t p = 0;
			size_t top = 0;
			while ( ( p = str.find_first_of( '\t', top ) ) != std::string::npos ) {
				std::string s = str.substr( top, p - top );
				list.push_back( s );
				top = p + 1;
			}
			std::string s = str.substr( top );
			list.push_back( s );
			return list;
		}

		std::vector< Data > dataList_;
	};
}

#endif
